Unit ASG2R_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc;

procedure ASG2R(var A :Array of Real; var B :Array of Real;
                var X :Array of Real; var S :Array of Integer;
                N :Integer; P :Integer);

implementation

procedure ASG2R(var A :Array of Real; var B :Array of Real;
                var X :Array of Real; var S :Array of Integer;
                N :Integer; P :Integer);
var
F,I,J,K,L,M,BP,BI,I1,BH :Integer;
BO,BK,BX,CC,CD,PR,Z,W,R :Real;
const
ZERO :Real = 0.0;
label
_1,_2,_3,_4,_5,_6,_7,_8,_9,_10,_11,_12,_13,_14,_15,_16;
begin
if ( N = 1 ) 
 then goto _15;
if ( P <> 1 ) 
 then goto _8;

F := 0;
_1:
F := F+1;
BK := ZERO;
for J:=F to N do
 begin
  BP := F;
  BO := ZERO;
  for I:=F to N do
   begin
    BX := Abs(A[(I-1)+(J-1)*N]);
    if ( BO >= BX ) 
     then goto _2;
    BO := BX;
    BP := I;
_2:
   end;
  if ( BK > BO ) 
   then goto _3;
  BK := BO;
  BH := BP;
  BI := J;
_3:
 end;
for I:=1 to N do
 begin
  CC := A[(I-1)+(BI-1)*N];
  A[(I-1)+(BI-1)*N] := A[(I-1)+(F-1)*N];
_4:
  A[(I-1)+(F-1)*N] := CC;
 end;
for J:=1 to N do
 begin
  CD := A[(BH-1)+(J-1)*N];
  A[(BH-1)+(J-1)*N] := A[(F-1)+(J-1)*N];
_5:
  A[(F-1)+(J-1)*N] := CD;
 end;
S[(F-1)+0*N] := BH;
S[(F-1)+1*N] := BI;
PR := 1.0/A[(F-1)+(F-1)*N];
L := F+1;
for I:=L to N do
 begin
_6:
  A[(I-1)+(F-1)*N] := -(PR*A[(I-1)+(F-1)*N]);
 end;
for J:=L to N do
 begin
  for I:=L to N do
   begin
_7:
    A[(I-1)+(J-1)*N] := A[(I-1)+(J-1)*N]+A[(F-1)+(J-1)*N]*A[(I-1)+(F-1)*N];
   end;
 end;
if ( L-N ) < 0
 then goto _1
 else if ( L-N ) > 0
       then goto _8
       else goto _8;

_8:
for I:=1 to N do
 begin
_9:
  X[I-1] := B[I-1];
 end;
M := N-1;
for I:=1 to M do
 begin
  I1 := S[(I-1)+0*N];
  Z := X[I1-1];
  X[I1-1] := X[I-1];
_10:
  X[I-1] := Z;
 end;
for J:=1 to M do
 begin
  W := X[J-1];
  K := J+1;
  for I:=K to N do
   begin
_11:
    X[I-1] := X[I-1]+A[(I-1)+(J-1)*N]*W;
   end;
 end;

X[N-1] := X[N-1]/A[(N-1)+(N-1)*N];
K := N;
for I:=1 to M do
 begin
  R := 0.0;
  L := K-1;
  for J:=K to N do
   begin
_12:
    R := R+A[(L-1)+(J-1)*N]*X[J-1];
   end;
  K := N-I;
_13:
  X[K-1] := (X[K-1]-R)/A[(K-1)+(K-1)*N];
 end;
for J:=1 to M do
 begin
  I := N-J;
  I1 := S[(I-1)+1*N];
  Z := X[I-1];
  X[I-1] := X[I1-1];
_14:
  X[I1-1] := Z;
 end;
goto _16;
_15:
X[0] := B[0]/A[0+0*N];
_16:
end;

end.
